/*
 *   ZeusMapper - create minimaps from Zeus scenarios and saved games
 *   Copyright (C) 2007  Bianca van Schaik
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License along
 *   with this program; if not, write to the Free Software Foundation, Inc.,
 *   51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */
/////////////////////////////////////////////////////////////////////////////
// Name:        bitmap.h
// Purpose:     wxBitmap class
// Author:      Julian Smart
// Modified by: Bianca van Schaik
// Created:     01/02/97
// RCS-ID:      $Id: pngdemo.h,v 1.8 2005/09/23 12:52:11 MR Exp $
// Copyright:   (c) Julian Smart
// Licence:     wxWindows license
/////////////////////////////////////////////////////////////////////////////

#include "wx/wx.h"

// Define a new application
class MyApp: public wxApp
{
  public:
    MyApp(void){};
    bool OnInit(void);
};

/**
* Canvas used for drawing the minimap on
*/
class ZeusCanvas: public wxScrolledWindow {
	public:
		ZeusCanvas(wxWindow *parent, const wxPoint& pos, const wxSize& size);
		~ZeusCanvas(void){};

		void OnPaint(wxPaintEvent& event);
DECLARE_EVENT_TABLE()
};

class MyFrame: public wxFrame
{
	public:
		ZeusCanvas *canvas;
		//wxNotebook *tabbedpane;
		MyFrame(wxFrame *parent, const wxString& title, const wxPoint& pos, const wxSize& size);
		virtual ~MyFrame();

		void OnActivate(bool) {}
		void OnLoadFile(wxCommandEvent& event);
		void OnSaveFile(wxCommandEvent& event);
		void OnQuit(wxCommandEvent& event);
		void OnAbout(wxCommandEvent& event);
		void OnHelp(wxCommandEvent& event);
		void OnLicence(wxCommandEvent& event);
		void OnSelectMap(wxCommandEvent& event);
DECLARE_EVENT_TABLE()
};

/**
* Custom dialog for the "Help" menu item. Displays a short bit of
* text detailing what the program does.
*/
class HelpDialog: public wxDialog {
	public:
		HelpDialog(
			wxWindow *parent,
			wxWindowID id,
			const wxString &title,
			const wxPoint& pos = wxDefaultPosition,
			const wxSize& size = wxDefaultSize,
			long style = wxDEFAULT_DIALOG_STYLE
		);
		~HelpDialog() {};
};

/**
* Custom dialog for the "Licence" menu item. Displays the licence
* of the program in a textbox.
*/
class LicenceDialog: public wxDialog {
	public:
		LicenceDialog(
			wxWindow *parent,
			wxWindowID id,
			const wxString &title,
			const wxPoint& pos = wxDefaultPosition,
			const wxSize& size = wxDefaultSize,
			long style = wxDEFAULT_DIALOG_STYLE
		);
		~LicenceDialog() {};
};

#define ZEUSMAPPER_QUIT       wxID_EXIT
#define ZEUSMAPPER_ABOUT      wxID_ABOUT
#define ZEUSMAPPER_LOAD_FILE  102
#define ZEUSMAPPER_SAVE_FILE  103
#define ZEUSMAPPER_HELP       104
#define ZEUSMAPPER_LICENCE    105
#define ZEUSMAPPER_SHOW_BASE  200
